Index: /trunk/.scm-settings
===================================================================
--- /trunk/.scm-settings	(revision 26511)
+++ /trunk/.scm-settings	(revision 26512)
@@ -51,4 +51,6 @@
 --filter-out-dirs  "*/src/VBox/Additions/solaris/SharedFolders/solaris10/sys/."
 --filter-out-dirs  "*/src/VBox/HostServices/SharedOpenGL/."
+--filter-out-dirs  "*/src/VBox/HostDrivers/VBoxNetFlt/solaris/include/."
+--filter-out-dirs  "*/src/VBox/HostDrivers/VBoxUSB/solaris/include/."
 --filter-out-dirs  "*/src/VBox/GuestHost/OpenGL/*/."
 --filter-out-dirs  "*/src/VBox/Devices/PC/Etherboot-src/*/."
@@ -71,4 +73,5 @@
 --filter-out-files "*/src/VBox/Devices/EFI/Firmware2/VBoxPkg/VBoxFsDxe/fsw_strfunc.h"
 --filter-out-files "*/src/VBox/Devices/Audio/sys-queue.h"
+--filter-out-files "*/src/VBox/HostDrivers/VBoxUSB/os2/usbcalls.h"
 
 
@@ -100,4 +103,5 @@
 --filter-out-dirs  "*/src/VBox/Devices/PC/PXE/."
 */src/VBox/Additions/solaris/Installer/postinstall.sh: --no-convert-tabs
+*/src/VBox/HostDrivers/Support/solaris/mod.sh: --no-convert-tabs
 
 # --no-convert-tabs
Index: /trunk/src/VBox/HostDrivers/Support/darwin/SUPLib-darwin.cpp
===================================================================
--- /trunk/src/VBox/HostDrivers/Support/darwin/SUPLib-darwin.cpp	(revision 26511)
+++ /trunk/src/VBox/HostDrivers/Support/darwin/SUPLib-darwin.cpp	(revision 26512)
@@ -267,5 +267,5 @@
 {
     if (RT_LIKELY(ioctl(pThis->hDevice, uFunction, pvReq) >= 0))
-	return VINF_SUCCESS;
+        return VINF_SUCCESS;
     return RTErrConvertFromErrno(errno);
 }
Index: /trunk/src/VBox/HostDrivers/Support/linux/SUPLib-linux.cpp
===================================================================
--- /trunk/src/VBox/HostDrivers/Support/linux/SUPLib-linux.cpp	(revision 26511)
+++ /trunk/src/VBox/HostDrivers/Support/linux/SUPLib-linux.cpp	(revision 26512)
@@ -182,5 +182,5 @@
      */
     if (RT_LIKELY(ioctl(pThis->hDevice, uFunction, pvReq) >= 0))
-	return VINF_SUCCESS;
+        return VINF_SUCCESS;
 
     /* This is the reverse operation of the one found in SUPDrv-linux.c */
@@ -217,28 +217,28 @@
     char *pvPages = (char *)mmap(NULL, cbMmap, PROT_READ | PROT_WRITE, MAP_PRIVATE | MAP_ANONYMOUS, -1, 0);
     if (pvPages == MAP_FAILED)
-	return VERR_NO_MEMORY;
+        return VERR_NO_MEMORY;
 
     if (pThis->fSysMadviseWorks)
     {
-	/*
-	 * It is not fatal if we fail here but a forked child (e.g. the ALSA sound server)
-	 * could crash. Linux < 2.6.16 does not implement madvise(MADV_DONTFORK) but the
-	 * kernel seems to split bigger VMAs and that is all that we want -- later we set the
-	 * VM_DONTCOPY attribute in supdrvOSLockMemOne().
-	 */
-	if (madvise (pvPages, cbMmap, MADV_DONTFORK))
-	    LogRel(("SUPLib: madvise %p-%p failed\n", pvPages, cbMmap));
-	*ppvPages = pvPages;
+        /*
+         * It is not fatal if we fail here but a forked child (e.g. the ALSA sound server)
+         * could crash. Linux < 2.6.16 does not implement madvise(MADV_DONTFORK) but the
+         * kernel seems to split bigger VMAs and that is all that we want -- later we set the
+         * VM_DONTCOPY attribute in supdrvOSLockMemOne().
+         */
+        if (madvise (pvPages, cbMmap, MADV_DONTFORK))
+            LogRel(("SUPLib: madvise %p-%p failed\n", pvPages, cbMmap));
+        *ppvPages = pvPages;
     }
     else
     {
-	/*
-	 * madvise(MADV_DONTFORK) is not available (most probably Linux 2.4). Enclose any
-	 * mmapped region by two unmapped pages to guarantee that there is exactly one VM
-	 * area struct of the very same size as the mmap area.
-	 */
-	mprotect(pvPages,                      PAGE_SIZE, PROT_NONE);
-	mprotect(pvPages + cbMmap - PAGE_SIZE, PAGE_SIZE, PROT_NONE);
-	*ppvPages = pvPages + PAGE_SIZE;
+        /*
+         * madvise(MADV_DONTFORK) is not available (most probably Linux 2.4). Enclose any
+         * mmapped region by two unmapped pages to guarantee that there is exactly one VM
+         * area struct of the very same size as the mmap area.
+         */
+        mprotect(pvPages,                      PAGE_SIZE, PROT_NONE);
+        mprotect(pvPages + cbMmap - PAGE_SIZE, PAGE_SIZE, PROT_NONE);
+        *ppvPages = pvPages + PAGE_SIZE;
     }
     memset(*ppvPages, 0, cPages << PAGE_SHIFT);
Index: /trunk/src/VBox/HostDrivers/Support/win/VBoxDrv.rc
===================================================================
--- /trunk/src/VBox/HostDrivers/Support/win/VBoxDrv.rc	(revision 26511)
+++ /trunk/src/VBox/HostDrivers/Support/win/VBoxDrv.rc	(revision 26512)
@@ -36,5 +36,5 @@
 VS_VERSION_INFO VERSIONINFO
    FILEVERSION          VBOX_VERSION_MAJOR_NR,VBOX_VERSION_MINOR_NR,VBOX_VERSION_BUILD_NR,0
-   PRODUCTVERSION	    VBOX_VERSION_MAJOR_NR,VBOX_VERSION_MINOR_NR,VBOX_VERSION_BUILD_NR,0
+   PRODUCTVERSION       VBOX_VERSION_MAJOR_NR,VBOX_VERSION_MINOR_NR,VBOX_VERSION_BUILD_NR,0
    FILEFLAGSMASK        VS_FFI_FILEFLAGSMASK
    FILEFLAGS            0x0L
@@ -49,9 +49,9 @@
          VALUE "CompanyName",      VBOX_RC_COMPANY_NAME
          VALUE "FileDescription",  "VirtualBox Support Driver\0"
-         VALUE "FileVersion",	   VBOX_VERSION_MAJOR "." VBOX_VERSION_MINOR "." VBOX_VERSION_BUILD ".r" VBOX_SVN_REV "\0"
+         VALUE "FileVersion",      VBOX_VERSION_MAJOR "." VBOX_VERSION_MINOR "." VBOX_VERSION_BUILD ".r" VBOX_SVN_REV "\0"
          VALUE "InternalName",     "VBoxDrv.sys\0"
          VALUE "LegalCopyright",   VBOX_RC_LEGAL_COPYRIGHT
          VALUE "OriginalFilename", "VBoxDrv.sys\0"
-         VALUE "ProductName",	   "Sun VirtualBox\0"
+         VALUE "ProductName",      "Sun VirtualBox\0"
          VALUE "ProductVersion",   VBOX_VERSION_MAJOR "." VBOX_VERSION_MINOR "." VBOX_VERSION_BUILD ".r" VBOX_SVN_REV "\0"
       END
Index: /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/VBoxNetFlt-win.c
===================================================================
--- /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/VBoxNetFlt-win.c	(revision 26511)
+++ /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/VBoxNetFlt-win.c	(revision 26512)
@@ -2188,6 +2188,6 @@
         if(RT_FAILURE(rc))
         {
-        	Assert(0);
-      		Status = Context.Status != NDIS_STATUS_SUCCESS ? Context.Status : NDIS_STATUS_FAILURE;
+            Assert(0);
+            Status = Context.Status != NDIS_STATUS_SUCCESS ? Context.Status : NDIS_STATUS_FAILURE;
             break;
         }
@@ -2206,5 +2206,5 @@
             {
                 Assert(0);
-          		Status = Context.Status != NDIS_STATUS_SUCCESS ? Context.Status : NDIS_STATUS_FAILURE;
+                Status = Context.Status != NDIS_STATUS_SUCCESS ? Context.Status : NDIS_STATUS_FAILURE;
                 /* release netflt */
                 vboxNetFltRelease(pInstance, false);
@@ -3545,23 +3545,23 @@
     for(;;)
     {
-    	if(fActive)
-    	{
-    		if(!pThis->u.s.cModePassThruRefs)
-    		{
-    			break;
-    		}
-    	}
-    	else
-    	{
-    		if(!pThis->u.s.cModeNetFltRefs)
-    		{
-    			break;
-    		}
-    	}
-		vboxNetFltWinSleep(2);
+        if(fActive)
+        {
+            if(!pThis->u.s.cModePassThruRefs)
+            {
+                break;
+            }
+        }
+        else
+        {
+            if(!pThis->u.s.cModeNetFltRefs)
+            {
+                break;
+            }
+        }
+        vboxNetFltWinSleep(2);
     }
 
     if(!vboxNetFltWinReferenceAdapt(pAdapt))
-    	return;
+        return;
 #ifndef VBOXNETADP
 
Index: /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/VBoxNetFlt-win.h
===================================================================
--- /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/VBoxNetFlt-win.h	(revision 26511)
+++ /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/VBoxNetFlt-win.h	(revision 26512)
@@ -484,42 +484,42 @@
 DECLINLINE(void) vboxNetFltWinReferenceModeNetFlt(PVBOXNETFLTINS pIns)
 {
-	ASMAtomicIncU32((volatile uint32_t *)&pIns->u.s.cModeNetFltRefs);
+    ASMAtomicIncU32((volatile uint32_t *)&pIns->u.s.cModeNetFltRefs);
 }
 
 DECLINLINE(void) vboxNetFltWinReferenceModePassThru(PVBOXNETFLTINS pIns)
 {
-	ASMAtomicIncU32((volatile uint32_t *)&pIns->u.s.cModePassThruRefs);
+    ASMAtomicIncU32((volatile uint32_t *)&pIns->u.s.cModePassThruRefs);
 }
 
 DECLINLINE(void) vboxNetFltWinIncReferenceModeNetFlt(PVBOXNETFLTINS pIns, uint32_t v)
 {
-	ASMAtomicAddU32((volatile uint32_t *)&pIns->u.s.cModeNetFltRefs, v);
+    ASMAtomicAddU32((volatile uint32_t *)&pIns->u.s.cModeNetFltRefs, v);
 }
 
 DECLINLINE(void) vboxNetFltWinIncReferenceModePassThru(PVBOXNETFLTINS pIns, uint32_t v)
 {
-	ASMAtomicAddU32((volatile uint32_t *)&pIns->u.s.cModePassThruRefs, v);
+    ASMAtomicAddU32((volatile uint32_t *)&pIns->u.s.cModePassThruRefs, v);
 }
 
 DECLINLINE(void) vboxNetFltWinDereferenceModeNetFlt(PVBOXNETFLTINS pIns)
 {
-	ASMAtomicDecU32((volatile uint32_t *)&pIns->u.s.cModeNetFltRefs);
+    ASMAtomicDecU32((volatile uint32_t *)&pIns->u.s.cModeNetFltRefs);
 }
 
 DECLINLINE(void) vboxNetFltWinDereferenceModePassThru(PVBOXNETFLTINS pIns)
 {
-	ASMAtomicDecU32((volatile uint32_t *)&pIns->u.s.cModePassThruRefs);
+    ASMAtomicDecU32((volatile uint32_t *)&pIns->u.s.cModePassThruRefs);
 }
 
 DECLINLINE(void) vboxNetFltWinDecReferenceModeNetFlt(PVBOXNETFLTINS pIns, uint32_t v)
 {
-	Assert(v);
-	ASMAtomicAddU32((volatile uint32_t *)&pIns->u.s.cModeNetFltRefs, (uint32_t)(-((int32_t)v)));
+    Assert(v);
+    ASMAtomicAddU32((volatile uint32_t *)&pIns->u.s.cModeNetFltRefs, (uint32_t)(-((int32_t)v)));
 }
 
 DECLINLINE(void) vboxNetFltWinDecReferenceModePassThru(PVBOXNETFLTINS pIns, uint32_t v)
 {
-	Assert(v);
-	ASMAtomicAddU32((volatile uint32_t *)&pIns->u.s.cModePassThruRefs, (uint32_t)(-((int32_t)v)));
+    Assert(v);
+    ASMAtomicAddU32((volatile uint32_t *)&pIns->u.s.cModePassThruRefs, (uint32_t)(-((int32_t)v)));
 }
 
@@ -593,5 +593,5 @@
 DECLINLINE(void) vboxNetFltWinDecReferenceDevice(PADAPT pAdapt, PADAPT_DEVICE pState, uint32_t v)
 {
-	Assert(v);
+    Assert(v);
     ASMAtomicAddU32((uint32_t volatile *)&pState->cReferences, (uint32_t)(-((int32_t)v)));
 }
@@ -607,5 +607,5 @@
 DECLINLINE(bool) vboxNetFltWinDoIncReferenceDevice(PADAPT pAdapt, PADAPT_DEVICE pState, uint32_t v)
 {
-	Assert(v);
+    Assert(v);
     if (vboxNetFltWinGetPowerState(pState) == NdisDeviceStateD0 && vboxNetFltWinGetOpState(pState) == kVBoxNetDevOpState_Initialized)
     {
@@ -678,5 +678,5 @@
     if(!ASMAtomicUoReadBool(&(pNetFlt)->fActive))
     {
-    	vboxNetFltWinReferenceModePassThru(pNetFlt);
+        vboxNetFltWinReferenceModePassThru(pNetFlt);
         RTSpinlockRelease((pNetFlt)->hSpinlock, &Tmp);
         *pbNetFltActive = false;
@@ -685,5 +685,5 @@
 
     vboxNetFltRetain((pNetFlt), true /* fBusy */);
-	vboxNetFltWinReferenceModeNetFlt(pNetFlt);
+    vboxNetFltWinReferenceModeNetFlt(pNetFlt);
     RTSpinlockRelease((pNetFlt)->hSpinlock, &Tmp);
 
@@ -760,5 +760,5 @@
     if(!ASMAtomicUoReadBool(&(pNetFlt)->fActive))
     {
-    	vboxNetFltWinIncReferenceModePassThru(pNetFlt, v);
+        vboxNetFltWinIncReferenceModePassThru(pNetFlt, v);
 
         RTSpinlockRelease((pNetFlt)->hSpinlock, &Tmp);
@@ -769,5 +769,5 @@
     vboxNetFltRetain(pNetFlt, true /* fBusy */);
 
-	vboxNetFltWinIncReferenceModeNetFlt(pNetFlt, v);
+    vboxNetFltWinIncReferenceModeNetFlt(pNetFlt, v);
 
     RTSpinlockRelease(pNetFlt->hSpinlock, &Tmp);
@@ -794,5 +794,5 @@
     }
 
-	vboxNetFltWinDecReferenceModeNetFlt(pNetFlt, n);
+    vboxNetFltWinDecReferenceModeNetFlt(pNetFlt, n);
 }
 
@@ -801,5 +801,5 @@
     vboxNetFltRelease(pNetFlt, true);
 
-	vboxNetFltWinDereferenceModeNetFlt(pNetFlt);
+    vboxNetFltWinDereferenceModeNetFlt(pNetFlt);
 }
 
Index: /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/VBoxNetFlt-win.rc
===================================================================
--- /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/VBoxNetFlt-win.rc	(revision 26511)
+++ /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/VBoxNetFlt-win.rc	(revision 26512)
@@ -30,5 +30,5 @@
 VS_VERSION_INFO VERSIONINFO
    FILEVERSION          VBOX_VERSION_MAJOR_NR,VBOX_VERSION_MINOR_NR,VBOX_VERSION_BUILD_NR,0
-   PRODUCTVERSION	    VBOX_VERSION_MAJOR_NR,VBOX_VERSION_MINOR_NR,VBOX_VERSION_BUILD_NR,0
+   PRODUCTVERSION       VBOX_VERSION_MAJOR_NR,VBOX_VERSION_MINOR_NR,VBOX_VERSION_BUILD_NR,0
    FILEFLAGSMASK        VS_FFI_FILEFLAGSMASK
    FILEFLAGS            0x0L
@@ -43,9 +43,9 @@
          VALUE "CompanyName",      VBOX_RC_COMPANY_NAME
          VALUE "FileDescription",  DESCRIPTION_STR
-         VALUE "FileVersion",	   VBOX_VERSION_MAJOR "." VBOX_VERSION_MINOR "." VBOX_VERSION_BUILD ".r" VBOX_SVN_REV "\0"
+         VALUE "FileVersion",      VBOX_VERSION_MAJOR "." VBOX_VERSION_MINOR "." VBOX_VERSION_BUILD ".r" VBOX_SVN_REV "\0"
          VALUE "InternalName",     FILENAME_STR
          VALUE "LegalCopyright",   VBOX_RC_LEGAL_COPYRIGHT
          VALUE "OriginalFilename", FILENAME_STR
-         VALUE "ProductName",	   "Sun VirtualBox\0"
+         VALUE "ProductName",      "Sun VirtualBox\0"
          VALUE "ProductVersion",   VBOX_VERSION_MAJOR "." VBOX_VERSION_MINOR "." VBOX_VERSION_BUILD ".r" VBOX_SVN_REV "\0"
       END
Index: /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/VBoxNetFltMp-win.c
===================================================================
--- /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/VBoxNetFltMp-win.c	(revision 26511)
+++ /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/VBoxNetFltMp-win.c	(revision 26512)
@@ -818,11 +818,11 @@
         if(bNetFltActive)
         {
-        	cNetFltRefs = cNumberOfPackets;
-        	cPassThruRefs = 0;
+            cNetFltRefs = cNumberOfPackets;
+            cPassThruRefs = 0;
         }
         else
         {
-        	cPassThruRefs = cNumberOfPackets;
-        	cNetFltRefs = 0;
+            cPassThruRefs = cNumberOfPackets;
+            cNetFltRefs = 0;
         }
 
@@ -1061,5 +1061,5 @@
             else if(fAdaptActive)
             {
-            	pAdapt->fProcessingPacketFilter = VBOXNETFLT_PFP_PASSTHRU;
+                pAdapt->fProcessingPacketFilter = VBOXNETFLT_PFP_PASSTHRU;
                 /* we're cleaning it in RequestComplete */
             }
@@ -1386,5 +1386,5 @@
         {
             /* need to disable cleaning promiscuous here ?? */
-        	bool fNetFltActive;
+            bool fNetFltActive;
             const bool fAdaptActive = vboxNetFltWinReferenceAdaptNetFlt(pNetFlt, pAdapt, &fNetFltActive);
 
Index: /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/VBoxNetFltPt-win.c
===================================================================
--- /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/VBoxNetFltPt-win.c	(revision 26511)
+++ /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/VBoxNetFltPt-win.c	(revision 26512)
@@ -582,13 +582,13 @@
         if(Oid == OID_GEN_CURRENT_PACKET_FILTER && VBOXNETFLT_PROMISCUOUS_SUPPORTED(pAdapt))
         {
-        	/* we're here _ONLY_ in the passthru mode */
-        	Assert(pAdapt->fProcessingPacketFilter == VBOXNETFLT_PFP_PASSTHRU);
-        	if(pAdapt->fProcessingPacketFilter == VBOXNETFLT_PFP_PASSTHRU)
-        	{
-				PVBOXNETFLTINS pNetFltIf = PADAPT_2_PVBOXNETFLTINS(pAdapt);
-				Assert(!pNetFltIf->fActive);
-				vboxNetFltWinDereferenceModePassThru(pNetFltIf);
-				vboxNetFltWinDereferenceAdapt(pAdapt);
-        	}
+            /* we're here _ONLY_ in the passthru mode */
+            Assert(pAdapt->fProcessingPacketFilter == VBOXNETFLT_PFP_PASSTHRU);
+            if(pAdapt->fProcessingPacketFilter == VBOXNETFLT_PFP_PASSTHRU)
+            {
+                PVBOXNETFLTINS pNetFltIf = PADAPT_2_PVBOXNETFLTINS(pAdapt);
+                Assert(!pNetFltIf->fActive);
+                vboxNetFltWinDereferenceModePassThru(pNetFltIf);
+                vboxNetFltWinDereferenceAdapt(pAdapt);
+            }
 
             if(Status == NDIS_STATUS_SUCCESS)
@@ -617,5 +617,5 @@
               if(pAdapt->fProcessingPacketFilter == VBOXNETFLT_PFP_NETFLT)
               {
-            	  Assert(pNetFltIf->fActive);
+                  Assert(pNetFltIf->fActive);
                   if(Status == NDIS_STATUS_SUCCESS)
                   {
@@ -629,5 +629,5 @@
               else if(pAdapt->fProcessingPacketFilter == VBOXNETFLT_PFP_PASSTHRU)
               {
-            	  Assert(!pNetFltIf->fActive);
+                  Assert(!pNetFltIf->fActive);
 
                   if(Status == NDIS_STATUS_SUCCESS)
Index: /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/WinNetConfig.cpp
===================================================================
--- /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/WinNetConfig.cpp	(revision 26511)
+++ /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/WinNetConfig.cpp	(revision 26512)
@@ -1753,5 +1753,5 @@
                 if(winEr != ERROR_INSUFFICIENT_BUFFER)
                 {
-                	Log(L"VBoxNetCfgWinEnumNetDevices: SetupDiGetDeviceRegistryPropertyW (1) failed winErr(%d)\n", winEr);
+                    Log(L"VBoxNetCfgWinEnumNetDevices: SetupDiGetDeviceRegistryPropertyW (1) failed winErr(%d)\n", winEr);
                     hr = HRESULT_FROM_WIN32(winEr);
                     break;
@@ -1775,5 +1775,5 @@
                 {
                     winEr = GetLastError();
-                	Log(L"VBoxNetCfgWinEnumNetDevices: SetupDiGetDeviceRegistryPropertyW (2) failed winErr(%d)\n", winEr);
+                    Log(L"VBoxNetCfgWinEnumNetDevices: SetupDiGetDeviceRegistryPropertyW (2) failed winErr(%d)\n", winEr);
                     hr = HRESULT_FROM_WIN32(winEr);
                     break;
@@ -1809,7 +1809,7 @@
     else
     {
-    	DWORD winEr = GetLastError();
-    	Log(L"VBoxNetCfgWinEnumNetDevices: SetupDiGetClassDevsExW failed winErr(%d)\n", winEr);
-    	hr = HRESULT_FROM_WIN32(winEr);
+        DWORD winEr = GetLastError();
+        Log(L"VBoxNetCfgWinEnumNetDevices: SetupDiGetClassDevsExW failed winErr(%d)\n", winEr);
+        hr = HRESULT_FROM_WIN32(winEr);
     }
 