Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManageDHCPServer.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManageDHCPServer.cpp	(revision 26587)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManageDHCPServer.cpp	(revision 26603)
@@ -230,5 +230,5 @@
 
         ComPtr<IHostNetworkInterface> hif;
-        CHECK_ERROR(host, FindHostNetworkInterfaceByName(Bstr(pIfName), hif.asOutParam()));
+        CHECK_ERROR(host, FindHostNetworkInterfaceByName(Bstr(pIfName).mutableRaw(), hif.asOutParam()));
         if(FAILED(rc))
             return errorArgument("could not find interface '%s'", pIfName);
@@ -244,5 +244,5 @@
 
     ComPtr<IDHCPServer> svr;
-    rc = a->virtualBox->FindDHCPServerByNetworkName(NetName, svr.asOutParam());
+    rc = a->virtualBox->FindDHCPServerByNetworkName(NetName.mutableRaw(), svr.asOutParam());
     if(enmCode == OP_ADD)
     {
@@ -250,5 +250,5 @@
             return errorArgument("dhcp server already exists");
 
-        CHECK_ERROR(a->virtualBox, CreateDHCPServer(NetName, svr.asOutParam()));
+        CHECK_ERROR(a->virtualBox, CreateDHCPServer(NetName.mutableRaw(), svr.asOutParam()));
         if(FAILED(rc))
             return errorArgument("failed to create server");
@@ -263,5 +263,5 @@
         if (pIp || pNetmask || pLowerIp || pUpperIp)
         {
-            CHECK_ERROR(svr, SetConfiguration(Bstr(pIp), Bstr(pNetmask), Bstr(pLowerIp), Bstr(pUpperIp)));
+            CHECK_ERROR(svr, SetConfiguration (Bstr(pIp).mutableRaw(), Bstr(pNetmask).mutableRaw(), Bstr(pLowerIp).mutableRaw(), Bstr(pUpperIp).mutableRaw()));
             if(FAILED(rc))
                 return errorArgument("failed to set configuration");
Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManageDisk.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManageDisk.cpp	(revision 26587)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManageDisk.cpp	(revision 26603)
@@ -255,5 +255,5 @@
 
     /* check the outcome */
-    if (   filename.isEmpty()
+    if (   !filename
         || sizeMB == 0)
         return errorSyntax(USAGE_CREATEHD, "Parameters --filename and --size are required");
@@ -281,5 +281,5 @@
         bool doClose = false;
 
-        if (!comment.isEmpty())
+        if (!comment.isNull())
         {
             CHECK_ERROR(hardDisk,COMSETTER(Description)(comment));
@@ -1012,5 +1012,5 @@
 
     /* check for required options */
-    if (server.isEmpty() || target.isEmpty())
+    if (!server || !target)
         return errorSyntax(USAGE_ADDISCSIDISK, "Parameters --server and --target are required");
 
@@ -1038,5 +1038,5 @@
         if (FAILED(rc)) break;
 
-        if (!port.isEmpty())
+        if (!port.isNull())
             server = BstrFmt ("%ls:%ls", server.raw(), port.raw());
 
@@ -1047,17 +1047,17 @@
         server.detachTo (values.appendedRaw());
         Bstr ("TargetName").detachTo (names.appendedRaw());
-        target.detachTo(values.appendedRaw());
-
-        if (!lun.isEmpty())
+        target.detachTo (values.appendedRaw());
+
+        if (!lun.isNull())
         {
             Bstr ("LUN").detachTo (names.appendedRaw());
             lun.detachTo (values.appendedRaw());
         }
-        if (!username.isEmpty())
+        if (!username.isNull())
         {
             Bstr ("InitiatorUsername").detachTo (names.appendedRaw());
             username.detachTo (values.appendedRaw());
         }
-        if (!password.isEmpty())
+        if (!password.isNull())
         {
             Bstr ("InitiatorSecret").detachTo (names.appendedRaw());
Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManageGuestProp.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManageGuestProp.cpp	(revision 26587)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManageGuestProp.cpp	(revision 26603)
@@ -248,11 +248,9 @@
             RTPrintf("No value set!\n");
         if (value)
+            RTPrintf("Value: %lS\n", value.raw());
+        if (value && verbose)
         {
-            RTPrintf("Value: %lS\n", value.raw());
-            if (verbose)
-            {
-                RTPrintf("Timestamp: %lld\n", u64Timestamp);
-                RTPrintf("Flags: %lS\n", flags.raw());
-            }
+            RTPrintf("Timestamp: %lld\n", u64Timestamp);
+            RTPrintf("Flags: %lS\n", flags.raw());
         }
     }
Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManageUSB.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManageUSB.cpp	(revision 26587)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManageUSB.cpp	(revision 26603)
@@ -364,5 +364,5 @@
                         && !cmd.mMachine)
                     || (   cmd.mGlobal
-                        && !cmd.mFilter.mRemote.isEmpty())
+                        && cmd.mFilter.mRemote)
                    )
                 {
@@ -441,14 +441,14 @@
                 if (!f.mActive.isNull())
                     CHECK_ERROR_BREAK (flt, COMSETTER(Active) (f.mActive));
-                if (!f.mVendorId.isEmpty())
-                    CHECK_ERROR_BREAK (flt, COMSETTER(VendorId)(f.mVendorId));
-                if (!f.mProductId.isEmpty())
-                    CHECK_ERROR_BREAK (flt, COMSETTER(ProductId) (f.mProductId));
-                if (!f.mRevision.isEmpty())
-                    CHECK_ERROR_BREAK (flt, COMSETTER(Revision) (f.mRevision));
-                if (!f.mManufacturer.isEmpty())
-                    CHECK_ERROR_BREAK (flt, COMSETTER(Manufacturer) (f.mManufacturer));
-                if (!f.mSerialNumber.isEmpty())
-                    CHECK_ERROR_BREAK (flt, COMSETTER(SerialNumber) (f.mSerialNumber));
+                if (!f.mVendorId.isNull())
+                    CHECK_ERROR_BREAK (flt, COMSETTER(VendorId) (f.mVendorId.setNullIfEmpty()));
+                if (!f.mProductId.isNull())
+                    CHECK_ERROR_BREAK (flt, COMSETTER(ProductId) (f.mProductId.setNullIfEmpty()));
+                if (!f.mRevision.isNull())
+                    CHECK_ERROR_BREAK (flt, COMSETTER(Revision) (f.mRevision.setNullIfEmpty()));
+                if (!f.mManufacturer.isNull())
+                    CHECK_ERROR_BREAK (flt, COMSETTER(Manufacturer) (f.mManufacturer.setNullIfEmpty()));
+                if (!f.mSerialNumber.isNull())
+                    CHECK_ERROR_BREAK (flt, COMSETTER(SerialNumber) (f.mSerialNumber.setNullIfEmpty()));
                 if (!f.mMaskedInterfaces.isNull())
                     CHECK_ERROR_BREAK (flt, COMSETTER(MaskedInterfaces) (f.mMaskedInterfaces));
@@ -466,16 +466,16 @@
                 if (!f.mActive.isNull())
                     CHECK_ERROR_BREAK (flt, COMSETTER(Active) (f.mActive));
-                if (!f.mVendorId.isEmpty())
-                    CHECK_ERROR_BREAK (flt, COMSETTER(VendorId) (f.mVendorId));
-                if (!f.mProductId.isEmpty())
-                    CHECK_ERROR_BREAK (flt, COMSETTER(ProductId) (f.mProductId));
-                if (!f.mRevision.isEmpty())
-                    CHECK_ERROR_BREAK (flt, COMSETTER(Revision) (f.mRevision));
-                if (!f.mManufacturer.isEmpty())
-                    CHECK_ERROR_BREAK (flt, COMSETTER(Manufacturer) (f.mManufacturer));
-                if (!f.mRemote.isEmpty())
-                    CHECK_ERROR_BREAK (flt, COMSETTER(Remote) (f.mRemote));
-                if (!f.mSerialNumber.isEmpty())
-                    CHECK_ERROR_BREAK (flt, COMSETTER(SerialNumber) (f.mSerialNumber));
+                if (!f.mVendorId.isNull())
+                    CHECK_ERROR_BREAK (flt, COMSETTER(VendorId) (f.mVendorId.setNullIfEmpty()));
+                if (!f.mProductId.isNull())
+                    CHECK_ERROR_BREAK (flt, COMSETTER(ProductId) (f.mProductId.setNullIfEmpty()));
+                if (!f.mRevision.isNull())
+                    CHECK_ERROR_BREAK (flt, COMSETTER(Revision) (f.mRevision.setNullIfEmpty()));
+                if (!f.mManufacturer.isNull())
+                    CHECK_ERROR_BREAK (flt, COMSETTER(Manufacturer) (f.mManufacturer.setNullIfEmpty()));
+                if (!f.mRemote.isNull())
+                    CHECK_ERROR_BREAK (flt, COMSETTER(Remote) (f.mRemote.setNullIfEmpty()));
+                if (!f.mSerialNumber.isNull())
+                    CHECK_ERROR_BREAK (flt, COMSETTER(SerialNumber) (f.mSerialNumber.setNullIfEmpty()));
                 if (!f.mMaskedInterfaces.isNull())
                     CHECK_ERROR_BREAK (flt, COMSETTER(MaskedInterfaces) (f.mMaskedInterfaces));
@@ -494,18 +494,18 @@
                 ComPtr <IHostUSBDeviceFilter> flt = coll[cmd.mIndex];
 
-                if (!f.mName.isEmpty())
-                    CHECK_ERROR_BREAK (flt, COMSETTER(Name) (f.mName));
+                if (!f.mName.isNull())
+                    CHECK_ERROR_BREAK (flt, COMSETTER(Name) (f.mName.setNullIfEmpty()));
                 if (!f.mActive.isNull())
                     CHECK_ERROR_BREAK (flt, COMSETTER(Active) (f.mActive));
-                if (!f.mVendorId.isEmpty())
-                    CHECK_ERROR_BREAK (flt, COMSETTER(VendorId) (f.mVendorId));
-                if (!f.mProductId.isEmpty())
-                    CHECK_ERROR_BREAK (flt, COMSETTER(ProductId) (f.mProductId));
-                if (!f.mRevision.isEmpty())
-                    CHECK_ERROR_BREAK (flt, COMSETTER(Revision) (f.mRevision));
-                if (!f.mManufacturer.isEmpty())
-                    CHECK_ERROR_BREAK (flt, COMSETTER(Manufacturer) (f.mManufacturer));
-                if (!f.mSerialNumber.isEmpty())
-                    CHECK_ERROR_BREAK (flt, COMSETTER(SerialNumber) (f.mSerialNumber));
+                if (!f.mVendorId.isNull())
+                    CHECK_ERROR_BREAK (flt, COMSETTER(VendorId) (f.mVendorId.setNullIfEmpty()));
+                if (!f.mProductId.isNull())
+                    CHECK_ERROR_BREAK (flt, COMSETTER(ProductId) (f.mProductId.setNullIfEmpty()));
+                if (!f.mRevision.isNull())
+                    CHECK_ERROR_BREAK (flt, COMSETTER(Revision) (f.mRevision.setNullIfEmpty()));
+                if (!f.mManufacturer.isNull())
+                    CHECK_ERROR_BREAK (flt, COMSETTER(Manufacturer) (f.mManufacturer.setNullIfEmpty()));
+                if (!f.mSerialNumber.isNull())
+                    CHECK_ERROR_BREAK (flt, COMSETTER(SerialNumber) (f.mSerialNumber.setNullIfEmpty()));
                 if (!f.mMaskedInterfaces.isNull())
                     CHECK_ERROR_BREAK (flt, COMSETTER(MaskedInterfaces) (f.mMaskedInterfaces));
@@ -521,20 +521,20 @@
                 ComPtr <IUSBDeviceFilter> flt = coll[cmd.mIndex];
 
-                if (!f.mName.isEmpty())
-                    CHECK_ERROR_BREAK (flt, COMSETTER(Name) (f.mName));
+                if (!f.mName.isNull())
+                    CHECK_ERROR_BREAK (flt, COMSETTER(Name) (f.mName.setNullIfEmpty()));
                 if (!f.mActive.isNull())
                     CHECK_ERROR_BREAK (flt, COMSETTER(Active) (f.mActive));
-                if (!f.mVendorId.isEmpty())
-                    CHECK_ERROR_BREAK (flt, COMSETTER(VendorId) (f.mVendorId));
-                if (!f.mProductId.isEmpty())
-                    CHECK_ERROR_BREAK (flt, COMSETTER(ProductId) (f.mProductId));
-                if (!f.mRevision.isEmpty())
-                    CHECK_ERROR_BREAK (flt, COMSETTER(Revision) (f.mRevision));
-                if (!f.mManufacturer.isEmpty())
-                    CHECK_ERROR_BREAK (flt, COMSETTER(Manufacturer) (f.mManufacturer));
-                if (!f.mRemote.isEmpty())
-                    CHECK_ERROR_BREAK (flt, COMSETTER(Remote) (f.mRemote));
-                if (!f.mSerialNumber.isEmpty())
-                    CHECK_ERROR_BREAK (flt, COMSETTER(SerialNumber) (f.mSerialNumber));
+                if (!f.mVendorId.isNull())
+                    CHECK_ERROR_BREAK (flt, COMSETTER(VendorId) (f.mVendorId.setNullIfEmpty()));
+                if (!f.mProductId.isNull())
+                    CHECK_ERROR_BREAK (flt, COMSETTER(ProductId) (f.mProductId.setNullIfEmpty()));
+                if (!f.mRevision.isNull())
+                    CHECK_ERROR_BREAK (flt, COMSETTER(Revision) (f.mRevision.setNullIfEmpty()));
+                if (!f.mManufacturer.isNull())
+                    CHECK_ERROR_BREAK (flt, COMSETTER(Manufacturer) (f.mManufacturer.setNullIfEmpty()));
+                if (!f.mRemote.isNull())
+                    CHECK_ERROR_BREAK (flt, COMSETTER(Remote) (f.mRemote.setNullIfEmpty()));
+                if (!f.mSerialNumber.isNull())
+                    CHECK_ERROR_BREAK (flt, COMSETTER(SerialNumber) (f.mSerialNumber.setNullIfEmpty()));
                 if (!f.mMaskedInterfaces.isNull())
                     CHECK_ERROR_BREAK (flt, COMSETTER(MaskedInterfaces) (f.mMaskedInterfaces));