Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.cpp	(revision 26799)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.cpp	(revision 26800)
@@ -397,4 +397,67 @@
 }
 
+void UIMachineWindow::prepareMenuMachine()
+{
+    QMenu *menu = machineLogic()->actionsPool()->action(UIActionIndex_Menu_Machine)->menu();
+
+    menu->clear();
+
+    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Toggle_Fullscreen));
+    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Toggle_Seamless));
+    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Toggle_GuestAutoresize));
+    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Simple_AdjustWindow));
+    menu->addSeparator();
+    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Toggle_MouseIntegration));
+    menu->addSeparator();
+    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Simple_TypeCAD));
+#ifdef Q_WS_X11
+    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Simple_TypeCABS));
+#endif
+    menu->addSeparator();
+    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Simple_TakeSnapshot));
+    menu->addSeparator();
+    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Simple_InformationDialog));
+    menu->addSeparator();
+    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Toggle_Pause));
+    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Simple_Reset));
+    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Simple_Shutdown));
+#ifndef Q_WS_MAC
+    menu->addSeparator();
+#endif /* Q_WS_MAC */
+    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Simple_Close));
+}
+
+void UIMachineWindow::prepareMenuDevices()
+{
+    QMenu *menu = machineLogic()->actionsPool()->action(UIActionIndex_Menu_Devices)->menu();
+
+    menu->clear();
+
+    /* Devices submenu */
+    menu->addMenu(machineLogic()->actionsPool()->action(UIActionIndex_Menu_OpticalDevices)->menu());
+    menu->addMenu(machineLogic()->actionsPool()->action(UIActionIndex_Menu_FloppyDevices)->menu());
+    menu->addMenu(machineLogic()->actionsPool()->action(UIActionIndex_Menu_USBDevices)->menu());
+    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Simple_NetworkAdaptersDialog));
+    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Simple_SharedFoldersDialog));
+    menu->addSeparator();
+    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Toggle_VRDP));
+    menu->addSeparator();
+    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Simple_InstallGuestTools));
+}
+
+#ifdef VBOX_WITH_DEBUGGER_GUI
+void UIMachineWindow::prepareMenuDebug()
+{
+    QMenu *menu = machineLogic()->actionsPool()->action(UIActionIndex_Menu_Debug)->menu();
+
+    menu->clear();
+
+    /* Debug submenu */
+    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Simple_Statistics));
+    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Simple_CommandLine));
+    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Toggle_Logging));
+}
+#endif /* VBOX_WITH_DEBUGGER_GUI */
+
 void UIMachineWindow::loadWindowSettings()
 {
@@ -439,65 +502,2 @@
 }
 
-void UIMachineWindow::prepareMenuMachine()
-{
-    QMenu *menu = machineLogic()->actionsPool()->action(UIActionIndex_Menu_Machine)->menu();
-
-    menu->clear();
-
-    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Toggle_Fullscreen));
-    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Toggle_Seamless));
-    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Toggle_GuestAutoresize));
-    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Simple_AdjustWindow));
-    menu->addSeparator();
-    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Toggle_MouseIntegration));
-    menu->addSeparator();
-    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Simple_TypeCAD));
-#ifdef Q_WS_X11
-    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Simple_TypeCABS));
-#endif
-    menu->addSeparator();
-    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Simple_TakeSnapshot));
-    menu->addSeparator();
-    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Simple_InformationDialog));
-    menu->addSeparator();
-    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Toggle_Pause));
-    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Simple_Reset));
-    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Simple_Shutdown));
-#ifndef Q_WS_MAC
-    menu->addSeparator();
-#endif /* Q_WS_MAC */
-    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Simple_Close));
-}
-
-void UIMachineWindow::prepareMenuDevices()
-{
-    QMenu *menu = machineLogic()->actionsPool()->action(UIActionIndex_Menu_Devices)->menu();
-
-    menu->clear();
-
-    /* Devices submenu */
-    menu->addMenu(machineLogic()->actionsPool()->action(UIActionIndex_Menu_OpticalDevices)->menu());
-    menu->addMenu(machineLogic()->actionsPool()->action(UIActionIndex_Menu_FloppyDevices)->menu());
-    menu->addMenu(machineLogic()->actionsPool()->action(UIActionIndex_Menu_USBDevices)->menu());
-    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Simple_NetworkAdaptersDialog));
-    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Simple_SharedFoldersDialog));
-    menu->addSeparator();
-    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Toggle_VRDP));
-    menu->addSeparator();
-    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Simple_InstallGuestTools));
-}
-
-#ifdef VBOX_WITH_DEBUGGER_GUI
-void UIMachineWindow::prepareMenuDebug()
-{
-    QMenu *menu = machineLogic()->actionsPool()->action(UIActionIndex_Menu_Debug)->menu();
-
-    menu->clear();
-
-    /* Debug submenu */
-    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Simple_Statistics));
-    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Simple_CommandLine));
-    menu->addAction(machineLogic()->actionsPool()->action(UIActionIndex_Toggle_Logging));
-}
-#endif /* VBOX_WITH_DEBUGGER_GUI */
-
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.h	(revision 26799)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.h	(revision 26800)
@@ -79,7 +79,12 @@
 
     /* Cleanup helpers: */
-    virtual void saveWindowSettings() {}
-    virtual void cleanupConsoleConnections() {}
-    virtual void cleanupWindowIcon() {}
+    //virtual void saveWindowSettings() {}
+#ifdef VBOX_WITH_DEBUGGER_GUI
+    //virtual void prepareMenuDebug() {}
+#endif
+    //virtual void prepareMenuDevices() {}
+    //virtual void prepareMenuMachine() {}
+    //virtual void cleanupConsoleConnections() {}
+    //virtual void cleanupWindowIcon() {}
 
     /* Update routines: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.cpp	(revision 26799)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.cpp	(revision 26800)
@@ -343,10 +343,10 @@
     /* Machine submenu: */
     QMenu *pMenuMachine = machineLogic()->actionsPool()->action(UIActionIndex_Menu_Machine)->menu();
-    UIMachineWindow::prepareMenuMachine();
+    prepareMenuMachine();
     menuBar()->addMenu(pMenuMachine);
 
     /* Devices submenu: */
     QMenu *pMenuDevices = machineLogic()->actionsPool()->action(UIActionIndex_Menu_Devices)->menu();
-    UIMachineWindow::prepareMenuDevices();
+    prepareMenuDevices();
     menuBar()->addMenu(pMenuDevices);
 
@@ -355,5 +355,5 @@
     {
         QMenu *pMenuDebug = machineLogic()->actionsPool()->action(UIActionIndex_Menu_Debug)->menu();
-        UIMachineWindow::prepareMenuDebug();
+        prepareMenuDebug();
         menuBar()->addMenu(pMenuDebug);
     }
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.h	(revision 26799)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.h	(revision 26800)
@@ -95,10 +95,10 @@
 
     /* Cleanup helpers: */
-    void cleanupMachineView() {}
+    //void cleanupMachineView() {}
     void saveWindowSettings();
-    void cleanupConnections() {}
+    //void cleanupConnections() {}
     void cleanupStatusBar();
-    void cleanupMenu() {}
-    void cleanupConsoleConnections() {}
+    //void cleanupMenu() {}
+    //void cleanupConsoleConnections() {}
 
     /* Indicators pool: */