Index: /trunk/src/VBox/Runtime/r3/posix/process-posix.cpp
===================================================================
--- /trunk/src/VBox/Runtime/r3/posix/process-posix.cpp	(revision 26803)
+++ /trunk/src/VBox/Runtime/r3/posix/process-posix.cpp	(revision 26804)
@@ -68,126 +68,8 @@
 RTR3DECL(int)   RTProcCreate(const char *pszExec, const char * const *papszArgs, RTENV Env, unsigned fFlags, PRTPROCESS pProcess)
 {
-#if 0
-    int rc;
-
-    /*
-     * Validate input.
-     */
-    AssertPtrReturn(pszExec, VERR_INVALID_POINTER);
-    AssertReturn(*pszExec, VERR_INVALID_PARAMETER);
-    AssertReturn(!(fFlags & ~RTPROC_FLAGS_DAEMONIZE), VERR_INVALID_PARAMETER);
-    AssertReturn(Env != NIL_RTENV, VERR_INVALID_PARAMETER);
-    const char * const *papszEnv = RTEnvGetExecEnvP(Env);
-    AssertPtrReturn(papszEnv, VERR_INVALID_HANDLE);
-    AssertPtrReturn(papszArgs, VERR_INVALID_PARAMETER);
-    /* later: path searching. */
-
-
-    /*
-     * Check for execute access to the file.
-     */
-    if (access(pszExec, X_OK))
-    {
-        rc = RTErrConvertFromErrno(errno);
-        AssertMsgFailed(("'%s' %Rrc!\n", pszExec, rc));
-        return rc;
-    }
-
-#if 0
-    /*
-     * Squeeze gdb --args in front of what's being spawned.
-     */
-    unsigned cArgs = 0;
-    while (papszArgs[cArgs])
-        cArgs++;
-    cArgs += 3;
-    const char **papszArgsTmp = (const char **)alloca(cArgs * sizeof(char *));
-    papszArgsTmp[0] = "/usr/bin/gdb";
-    papszArgsTmp[1] = "--args";
-    papszArgsTmp[2] = pszExec;
-    for (unsigned i = 1; papszArgs[i]; i++)
-        papszArgsTmp[i + 2] = papszArgs[i];
-    papszArgsTmp[cArgs - 1] = NULL;
-    pszExec = papszArgsTmp[0];
-    papszArgs = papszArgsTmp;
-#endif
-
-    /*
-     * Spawn the child.
-     *
-     * HACK ALERT! Put the process into a new process group with pgid = pid
-     * to make sure it differs from that of the parent process to ensure that
-     * the IPRT waipit call doesn't race anyone (read XPCOM) doing group wide
-     * waits.
-     */
-    pid_t pid;
-#ifdef HAVE_POSIX_SPAWN
-    if (!(fFlags & RTPROC_FLAGS_DAEMONIZE))
-    {
-        posix_spawnattr_t Attr;
-
-        rc = posix_spawnattr_init(&Attr);
-        if (!rc)
-        {
-# ifndef RT_OS_OS2 /* We don't need this on OS/2 and I don't recall if it's actually implemented. */
-            rc = posix_spawnattr_setflags(&Attr, POSIX_SPAWN_SETPGROUP);
-            Assert(rc == 0);
-            if (!rc)
-            {
-                rc = posix_spawnattr_setpgroup(&Attr, 0 /* pg == child pid */);
-                Assert(rc == 0);
-            }
-# endif
-            if (!rc)
-            {
-                rc = posix_spawn(&pid, pszExec, NULL, &Attr, (char * const *)papszArgs,
-                                 (char * const *)papszEnv);
-                if (!rc)
-                {
-                    int rc2 = posix_spawnattr_destroy(&Attr); Assert(rc2 == 0); NOREF(rc2);
-                    if (pProcess)
-                        *pProcess = pid;
-                    return VINF_SUCCESS;
-                }
-            }
-            int rc2 = posix_spawnattr_destroy(&Attr); Assert(rc2 == 0); NOREF(rc2);
-        }
-    }
-    else
-#endif
-    {
-        pid = fork();
-        if (!pid)
-        {
-            setpgid(0, 0); /* see comment above */
-
-            if (fFlags & RTPROC_FLAGS_DAEMONIZE)
-            {
-                rc = RTProcDaemonize(true /* fNoChDir */, false /* fNoClose */, NULL /* pszPidFile */);
-                AssertReleaseMsgFailed(("RTProcDaemonize returns %Rrc errno=%d\n", rc, errno));
-                exit(127);
-            }
-            rc = execve(pszExec, (char * const *)papszArgs, (char * const *)papszEnv);
-            AssertReleaseMsgFailed(("execve returns %d errno=%d\n", rc, errno));
-            exit(127);
-        }
-        if (pid > 0)
-        {
-            if (pProcess)
-                *pProcess = pid;
-            return VINF_SUCCESS;
-        }
-        rc = errno;
-    }
-
-    /* failure, errno value in rc. */
-    AssertMsgFailed(("spawn/exec failed rc=%d\n", rc)); /* this migth be annoying... */
-    return RTErrConvertFromErrno(rc);
-#else
     return RTProcCreateEx(pszExec, papszArgs, Env, fFlags,
                           NULL, NULL, NULL,  /* standard handles */
                           NULL /*pszAsUser*/,
                           pProcess);
-#endif
 }
 