Index: /trunk/include/iprt/poll.h
===================================================================
--- /trunk/include/iprt/poll.h	(revision 26826)
+++ /trunk/include/iprt/poll.h	(revision 26827)
@@ -181,5 +181,5 @@
  * @param   hPollSet            The poll set.
  */
-RTDECL(uint32_t) RTPollSetCount(RTPOLLSET hPollSet);
+RTDECL(uint32_t) RTPollGetCount(RTPOLLSET hPollSet);
 
 /**
Index: /trunk/src/VBox/Runtime/r3/os2/poll-os2.cpp
===================================================================
--- /trunk/src/VBox/Runtime/r3/os2/poll-os2.cpp	(revision 26826)
+++ /trunk/src/VBox/Runtime/r3/os2/poll-os2.cpp	(revision 26827)
@@ -83,5 +83,5 @@
 
 
-RTDECL(uint32_t) RTPollSetCount(RTPOLLSET hPollSet)
+RTDECL(uint32_t) RTPollGetCount(RTPOLLSET hPollSet)
 {
     return UINT32_MAX;
Index: /trunk/src/VBox/Runtime/r3/posix/poll-posix.cpp
===================================================================
--- /trunk/src/VBox/Runtime/r3/posix/poll-posix.cpp	(revision 26826)
+++ /trunk/src/VBox/Runtime/r3/posix/poll-posix.cpp	(revision 26827)
@@ -464,5 +464,5 @@
 
 
-RTDECL(uint32_t) RTPollSetCount(RTPOLLSET hPollSet)
+RTDECL(uint32_t) RTPollGetCount(RTPOLLSET hPollSet)
 {
     /*
Index: /trunk/src/VBox/Runtime/r3/win/poll-win.cpp
===================================================================
--- /trunk/src/VBox/Runtime/r3/win/poll-win.cpp	(revision 26826)
+++ /trunk/src/VBox/Runtime/r3/win/poll-win.cpp	(revision 26827)
@@ -83,5 +83,5 @@
 
 
-RTDECL(uint32_t) RTPollSetCount(RTPOLLSET hPollSet)
+RTDECL(uint32_t) RTPollGetCount(RTPOLLSET hPollSet)
 {
     return UINT32_MAX;
Index: /trunk/src/VBox/Runtime/testcase/tstRTPoll.cpp
===================================================================
--- /trunk/src/VBox/Runtime/testcase/tstRTPoll.cpp	(revision 26826)
+++ /trunk/src/VBox/Runtime/testcase/tstRTPoll.cpp	(revision 26827)
@@ -59,5 +59,5 @@
     RTTESTI_CHECK_RC(RTPollSetRemove(hSetInvl, 1), VERR_INVALID_HANDLE);
     RTTESTI_CHECK_RC(RTPollSetQueryHandle(hSetInvl, 1, NULL), VERR_INVALID_HANDLE);
-    RTTESTI_CHECK(RTPollSetCount(hSetInvl) == UINT32_MAX);
+    RTTESTI_CHECK(RTPollGetCount(hSetInvl) == UINT32_MAX);
     RTTESTI_CHECK_RC(RTPoll(hSetInvl, 0, NULL, NULL),  VERR_INVALID_HANDLE);
     RTTESTI_CHECK_RC(RTPollNoResume(hSetInvl, 0, NULL, NULL),  VERR_INVALID_HANDLE);
@@ -125,12 +125,12 @@
     RTTESTI_CHECK_RETV(hSet != NIL_RTPOLLSET);
 
-    RTTESTI_CHECK_RETV(RTPollSetCount(hSet) == 0);
+    RTTESTI_CHECK_RETV(RTPollGetCount(hSet) == 0);
     RTTESTI_CHECK_RC(RTPollSetQueryHandle(hSet, 0, NULL), VERR_POLL_HANDLE_ID_NOT_FOUND);
 
     RTTESTI_CHECK_RC(RTPollSetAddPipe(hSet, NIL_RTPIPE, RTPOLL_EVT_READ, 1 /*id*/), VINF_SUCCESS);
-    RTTESTI_CHECK_RETV(RTPollSetCount(hSet) == 0);
+    RTTESTI_CHECK_RETV(RTPollGetCount(hSet) == 0);
     RTTESTI_CHECK_RC(RTPollSetQueryHandle(hSet, 1 /*id*/, NULL), VERR_POLL_HANDLE_ID_NOT_FOUND);
     RTTESTI_CHECK_RC(RTPollSetRemove(hSet, 0), VERR_POLL_HANDLE_ID_NOT_FOUND);
-    RTTESTI_CHECK_RETV(RTPollSetCount(hSet) == 0);
+    RTTESTI_CHECK_RETV(RTPollGetCount(hSet) == 0);
 
     RTTESTI_CHECK_RC(RTPollSetDestroy(hSet), VINF_SUCCESS);
@@ -149,5 +149,5 @@
     /* add the read pipe */
     RTTESTI_CHECK_RC_RETV(RTPollSetAddPipe(hSet, hPipeR, RTPOLL_EVT_READ, 1 /*id*/), VINF_SUCCESS);
-    RTTESTI_CHECK_RETV(RTPollSetCount(hSet) == 1);
+    RTTESTI_CHECK_RETV(RTPollGetCount(hSet) == 1);
     RTTESTI_CHECK_RC(RTPollSetQueryHandle(hSet, 1 /*id*/, NULL), VINF_SUCCESS);
     RTHANDLE Handle;
@@ -162,5 +162,5 @@
     /* add the write pipe */
     RTTESTI_CHECK_RC(RTPollSetAddPipe(hSet, hPipeW, RTPOLL_EVT_WRITE, 10 /*id*/), VINF_SUCCESS);
-    RTTESTI_CHECK_RETV(RTPollSetCount(hSet) == 2);
+    RTTESTI_CHECK_RETV(RTPollGetCount(hSet) == 2);
     RTTESTI_CHECK_RC(RTPollSetQueryHandle(hSet, 10 /*id*/, NULL), VINF_SUCCESS);
 
@@ -276,5 +276,5 @@
     /* Remove the read pipe, do a quick poll check. */
     RTTESTI_CHECK_RC_RETV(RTPollSetRemove(hSet, 1), VINF_SUCCESS);
-    RTTESTI_CHECK_RETV(RTPollSetCount(hSet) == 1);
+    RTTESTI_CHECK_RETV(RTPollGetCount(hSet) == 1);
     RTTESTI_CHECK_RC(RTPollSetQueryHandle(hSet, 1 /*id*/, NULL), VERR_POLL_HANDLE_ID_NOT_FOUND);
     RTTESTI_CHECK_RC_RETV(RTPollSetQueryHandle(hSet, 10 /*id*/, &Handle), VINF_SUCCESS);
@@ -289,5 +289,5 @@
 
     RTTESTI_CHECK_RC_RETV(RTPollSetAddPipe(hSet, hPipeR, RTPOLL_EVT_READ, 1 /*id*/), VINF_SUCCESS);
-    RTTESTI_CHECK_RETV(RTPollSetCount(hSet) == 2);
+    RTTESTI_CHECK_RETV(RTPollGetCount(hSet) == 2);
     RTTESTI_CHECK_RC(RTPollSetQueryHandle(hSet, 1 /*id*/, NULL), VINF_SUCCESS);
 
@@ -308,5 +308,5 @@
     /* Remove it again and break the pipe by closing the read end. */
     RTTESTI_CHECK_RC_RETV(RTPollSetRemove(hSet, 1), VINF_SUCCESS);
-    RTTESTI_CHECK_RETV(RTPollSetCount(hSet) == 1);
+    RTTESTI_CHECK_RETV(RTPollGetCount(hSet) == 1);
     RTTESTI_CHECK_RC(RTPollSetQueryHandle(hSet, 1 /*id*/, NULL), VERR_POLL_HANDLE_ID_NOT_FOUND);
     RTTESTI_CHECK_RC_RETV(RTPollSetQueryHandle(hSet, 10 /*id*/, &Handle), VINF_SUCCESS);